// CD 05/06
// Demo librairie TIME , base de temps sur debordement TIMER1
// fonctionne en moide simulation ( faire "" debugger-settings-UART1 IO cocher les deux cases)
// ou 
// connecter un mulateur de terminal sur le pour srie de PICDEM2+
// Attention au cable PC (brochage RX/TX)
// l'heure et la date sont initialisees pour l'exemple au vendredi 26 mai 2006 15h25mn10s 
#pragma config WDT = OFF
#pragma config OSC = XT
#pragma config LVP=OFF

#include <p18f452.h>
#include <stdio.h>		// pour fprintf
#include "time.h"

struct tm tblock;// structure date et heure pour l'exemple
struct tm *tmtemp;
time_t timerCAL=0;			// compteur de secondes heure calendaire
clock_t timerCPU=0;			// compteur de secondes heure processeur
			
unsigned char maj=1;		// indique un changement du temps TIMER
unsigned char tampon[30];

// ex: la base de temps est le TIMER1 avec un quart 4MHz, IT toutes les 500 ms.
#pragma interrupt traite_it
void traite_it(void)		
{static char tictac;
	if( PIR1bits.TMR1IF)	// l'IT provient d'une comparaison
			{						
			if (tictac++)	// prise en compte d'une IT/2
				{
				timerCAL++;	// maj heure calendaire
				timerCPU++;	// maj heure processeur
				maj=1;		// nouvelle heure disponible
				tictac=0;	// ignorera la prochaine IT
				}
			TMR1L=0x24;	 // VOIR CI DESSOUS
			TMR1H=0xF4;
			PIR1bits.TMR1IF=0;		//efface le drapeau d'IT
			}
}			

void copietm(struct tm *source,struct tm *dest)
{
	dest->tm_sec=source->tm_sec;	
	dest->tm_min=source->tm_min;
	dest->tm_hour=source->tm_hour;
	dest->tm_mday=source->tm_mday;
	dest->tm_mon=source->tm_mon;	
	dest->tm_year=source->tm_year; 	
	dest->tm_wday=source->tm_wday;
}

#pragma code vec_it=0x08
void vect8 (void)
{
_asm goto traite_it  _endasm
}
#pragma code


void main(void)
{
    SPBRG = 25; 	           			/* configure la vitesse (BAUD) 9600 N 8 1*/
    TXSTA = 0x24; 	                  
    RCSTA = 0x90;			 			/* active l'USART*/

	// IT toutes les 500 ms. periode TIMER 1: 8uS cahrgement TIMER1 : 500000/8=62500=0xF424
	TMR1L=0x24;	
	TMR1H=0xF4;
	T1CON=0b10111101;	//16bits, prediv 8, synchro, h interne, timer actif
	PIE1bits.TMR1IE=1;	// autorise les IT TIMER1 sur debordement
	RCONbits.IPEN=1;
	INTCONbits.GIE=1;	

// l'heure locale doit etre initialisee par l'utilisateur , par exemple : 	
	tblock.tm_sec=7;	
	tblock.tm_min=25;
	tblock.tm_hour=15;
	tblock.tm_mday=26;	// le 26
	tblock.tm_mon=4;	// mai
	tblock.tm_year=106; // 106 ans depuis 1900	
	tblock.tm_wday=5;	// vendredi
	timerCAL=mktime(&tblock);	// convertit heure locale en heure calendaire (en secondes) et le range dans timerCAL

fprintf(_H_USART,"\n\rDemo RTC sur PIC18 \n");

while(1)						
	    {
		      if (maj)
					{
						 maj=0;
						 tmtemp = localtime(&timerCAL);																// convertit l'heure calendaire en heure locale
						 copietm(tmtemp,&tblock);																	// range le resultat (si besoin)
						 fprintf(_H_USART,"\nl'heure avec asctime (depuis tblock): %s\n", asctime(&tblock)); 		// affiche a partir de tblock
						 fprintf(_H_USART,"l'heure avec ctime (depuis timerCAL): %s\n",ctime(&timerCAL));			// idem a partir de timerCAL
						 fprintf(_H_USART,"heure processeur: %lu secondesdepuis reset\n", clock());  				// le compteur de secondes
						 fprintf(_H_USART,"heure calendaire: %lu secondes depuis le 1/1/1970\n", time(&timerCAL));  // l'heure calendaire
						 strftime(tampon,30,"%j", &tblock);															// recuperation d'un element de la structure tblock
						 fprintf(_H_USART,"numero du jour de l'annee %s \n",tampon);
					}			
    	}
}
